/* Solution: DOMINO */

#include <stdio.h>
#include <stdlib.h>

#define MAX_GRAPH_SIZE 100

FILE *inp;

long m,n;
long graph[MAX_GRAPH_SIZE][MAX_GRAPH_SIZE];
long t[MAX_GRAPH_SIZE];
long caseno=1;

min(long a, long b)
{
	return (a>b)?b:a; 
}

long max(long a, long b)
{ 
	return (a<b)?b:a; 
}

void solve_case()
{
  long ch,i,j,m1,m2,solnum;
  double tim,maxtim;
  
  /* 1. Compute for each key stone the t until the stone falls down */

  for(i=1;i<n;i++) t[i] = -1;
  t[0] = 0; ch = 1;
  while(ch)
    {
      ch = 0;
      for(i=1;i<n;i++)
	for(j=0;j<n;j++)
	  if(graph[j][i] >= 0 && t[j] >= 0 &&
	     (t[i] < 0 || t[j] + graph[j][i] < t[i]))
	    {
	      t[i] = t[j] + graph[j][i];
	      ch = 1;
	    }
    }

  /* 2. Check for the maximum among these times */

  maxtim = -1; solnum = 0;
  for(i=0;i<n;i++)
    {
      if(t[i] >= 0 && (double) t[i] >= maxtim)
	if(t[i] > maxtim)
	  { maxtim = (double) t[i]; m1 = i; m2 = -1; solnum = 1; }
	else solnum++;
      if(t[i] == -1)
	printf("*** INPUT ERROR: graph is not connected!\n");
    }

  /* 3. Check whether the last stone falls on a row between two key stones */

  for(i=0;i<n;i++)
    for(j=i;j<n;j++)
      if(t[i] >= 0 && t[j] >= 0 && graph[i][j] >= 0)
	{
	  tim = 0.5*(graph[i][j] - abs(t[i]-t[j])) +
	    (double) max(t[i],t[j]);
	  if(tim == maxtim && tim > t[i] && tim > t[j]) solnum++;
	  if(tim > maxtim)
	    { maxtim = tim; m1 = i; m2 = j; solnum = 1; }
	}

  /* 4. Output the solution */

  printf("System #%d\n",caseno++);
  if(solnum != 1)
    printf("*** INPUT ERROR: Output is ambiguous.\n");
  printf("The last domino falls after %.1lf seconds, ",maxtim);
  if(m2 < 0)
    printf("at key domino %ld.\n\n",m1+1);
  else
    printf("between key dominoes %ld and %ld.\n\n",m1+1,m2+1);
}

void skip_line() { while(getc(inp) >= ' '); }

long read_case()
{
  long i,j,v1,v2,w;

  fscanf(inp,"%ld %ld",&n,&m); skip_line();
  if(n == 0 && m == 0) return 0;
  for(i=0;i<n;i++)
    for(j=0;j<n;j++) graph[i][j] = -1;
  for(i=0;i<m;i++)
    {
      fscanf(inp,"%ld %ld %ld",&v1,&v2,&w); skip_line();
      v1--; v2--;
      graph[v1][v2] = graph[v2][v1] = w;
    }
  return 1;
}

long main()
{
  inp = fopen("domino.in","r");
  while(read_case())
	solve_case();
  fclose(inp);
  return 0;
}

