{$R-,S-,Q-,N+}

const
  finp = 'money.in';
  fout = 'money.out';
  maxn = 12;
  maxm = 60;
  maxlen = 80;
  e = 1e-5;
  mask = 9973;

type
  TBigNumber = record
    l: integer;
    num: array[1 .. maxlen] of byte;
  end;
  Tline = array[0 .. mask] of byte;

var
  n, m, x, y: integer;
  ls: array[1 .. maxn] of integer;
  dd: array[1 .. maxm] of extended;
  mins: array[0 .. maxn] of extended;
  maxs: array[0 .. maxm, 0 .. maxn] of extended;
  mmask: array[0 .. maxm] of integer;
  vs: array[0 .. maxm] of TBigNumber;
  f: array[1 .. maxm + 1] of ^Tline;
  temp: TBigNumber;
  xy: extended;
  sum: longint;

procedure inith(var x: TBigNumber; k: integer);
begin
  fillchar(x, sizeof(x), 0);
  x.l := 1; x.num[x.l] := k;
end;

procedure mul(var x: TBigNumber; k: integer);
var
  i, v, p: integer;
begin
  p := 0;
  for i := 1 to x.l do begin
    v := x.num[i] * k + p;
    p := v div 10;
    x.num[i]:= v mod 10;
  end;
  while p > 0 do begin
    x.l := x.l + 1;
    x.num[x.l] := p mod 10;
    p := p div 10;
  end;
end;

procedure add(var x, y: TBigNumber);
var
  i: integer;
begin
  if y.l > x.l then x.l := y.l;
  for i := 1 to x.l do begin
    x.num[i] := x.num[i] + y.num[i];
    if x.num[i] >= 10 then begin
      x.num[i] := x.num[i] - 10;
      x.num[i + 1] := x.num[i + 1] + 1;
    end;
  end;
  if x.num[x.l + 1] <> 0 then x.l := x.l + 1;
end;

function same(const x, y: TBigNumber): boolean;
var
  i: integer;
begin
  same := false;
  if x.l <> y.l then exit;
  for i := 1 to x.l do if x.num[i] <> y.num[i] then exit;
  same := true;
end;

procedure init;
var
  i, k: integer;
  s: longint;
begin

  sum := 0;
  xy := x / y;

  for i := 0 to m do begin
    if i = 0 then s := x else s := y;
    inith(vs[i], s);
    for k := 1 to m do
      if k <> i then begin
        s := (s * k) mod mask;
        mul(vs[i], k);
      end;
    mmask[i] := s;
  end;

  for i := 1 to m + 1 do new(f[i]);
  f[m + 1]^[0] := 0;
  for i := 1 to mask - 1 do f[m + 1]^[i] := n + 1;
  for i := m downto 1 do begin
    f[i]^ := f[i + 1]^;
    for s := 0 to mask - 1 do begin
      k := f[i + 1]^[(s - mmask[i] + mask) mod mask] + 1;
      if k < f[i]^[s] then f[i]^[s] := k;
    end;
  end;

  mins[0] := 0;
  for i := 1 to n do mins[i] := mins[i - 1] + 1 / (m - i + 1);
  for i := 0 to m do begin
    maxs[i, 0] := 0;
    for k := 1 to n do maxs[i, k] := maxs[i, k - 1] + 1 / (i + k);
  end;
  for i := 1 to m do dd[i] := 1 / i;

end;

procedure search(d, last, smask: integer; s: extended);
var
  i: integer;
begin
  if (s + maxs[last, d] < xy - e) or
     (s + mins[d] > xy + e) or
     (f[last + 1]^[smask] > d) then
    exit;
  if d = 0 then begin
    inith(temp, 0);
    for i := 1 to n do add(temp, vs[ls[i]]);
    if same(temp, vs[0]) then sum := sum + 1;
    exit;
  end;
  smask := smask + mask;
  for i := last + 1 to m - d + 1 do begin
    ls[d] := i;
    search(d - 1, i, (smask - mmask[i]) mod mask, s + dd[i]);
  end;
end;

begin
  assign(input, finp);
  reset(input);
  readln(n, m, x, y);
  close(input);
  init;
  search(n, 0, mmask[0], 0);
  assign(output, fout);
  rewrite(output);
  writeln(sum);
  close(output);
end.
