#include <cstdio>
#include <string>

using namespace std;

const int MAXRE = 550; // ʽ
const int MAXSIGMA = 10; // ַʹС
const int MAXNFA = MAXRE * 2; // NFA н
const int BIT = 32; // ֳ
const int MAXMM = MAXNFA / BIT;
const int HASH_SIZE = 1 << 20; // ϣС1048573 is a prime
const int BUF_SIZE = 1 << 12;

struct T_HASH
{
	int *node, *g, id;
	T_HASH *next;
} **hash, **gg; // HASH_SIZE * 4 = 4M

struct T_LIST
{
	int l, p[MAXMM], value[MAXMM];
} nx[MAXSIGMA][MAXNFA]; // 2M

int m, n, mm, sz, max_sz, sm, s, t, sigma, start[MAXMM], pow[BIT], *g[MAXNFA]; // 4M
bool *final, keep[MAXNFA];

int build_eNFA(const char *regular, int a, int b)
{
	int p = 0, q = 0, min = MAXRE * 4;
	for (int i = a; i <= b; i ++)
	{
		int k = min + 1;
		switch (regular[i])
		{
		case '(': k = q + 2; q = q + 4; break;
		case ')': q = q - 4; break;
		case '+': k = q + 1; break;
		case '*': k = q + 3; break;
		default : k = q + 2;
		}
		if (k <= min && i > a && regular[i - 1] != '(')
		{
			min = k;
			p = i;
		}
	}
	if ((a += (min / 4)) >= (b -= (min / 4)))
	{
		g[s = n ++][t = ++ n] = 1 << (regular[(a + b) / 2] - '0' + 1); 
		return (int)(keep[s] = true);
	}
	int rr = build_eNFA(regular, a, p - 1), ll = 0, ss = s, tt = t;
	switch (regular[p])
	{
	case '*': g[ss][tt] |= 1; g[tt][ss] |= 1; return 0;
	case '+':
		ll = build_eNFA(regular, p + 1, b);
		if (ll == 1 && rr != 0)
		{
			if ((g[ss][tt] |= g[s][t]) > 1)  keep[ss] = true;
			s = ss; t = tt;
			return rr;
		}
		if (true || rr == 0 || ll == 0 || (rr == 2 && ll == 2)) 
		{
			g[p = n ++][ss] |= 1; g[p][s] |= 1;	g[tt][q = n++] |= 1; g[t][q] |= 1;
			s = p; t = q;
		} 
		else if ((g[s][t] |= g[ss][tt]) > 1) keep[s] = true;
		return 2;
	default:
		rr = (build_eNFA(regular, p, b) == 0) ? 0 : 2;
		if (g[t][s] != 0) g[tt][s] |= 1;				
		for (int i = 0; i < n; i ++) if ((g[tt][i] |= g[s][i]) > 1) keep[tt] = true;
		s = ss;
	}
	return rr;
}

void remove_epsilon()
{
	int v[MAXNFA] = {0}, q[MAXNFA] = {0}, E[MAXNFA][MAXMM] = {0}, idx[MAXNFA], len = 0;
	keep[s] = keep[t] = true; 
	for (int i = 0; i < n; i ++)
		if (!keep[i])
		{
			for (int p = 0; p < n; p ++)
				if (g[i][p] == 1) // i -> p is epsilon
					for (int k = 0; k < n; k ++)
						g[k][p] |= g[k][i];
			for (int k = 0; k < n; k ++) g[k][i] = 0;
		}
	v[q[len ++] = s] = 1;
	while (len -- > 0) 
	{
		int k = q[len];
		for (int p = 0; p < n; p ++) if (g[k][p] != 0 && v[p] == 0) v[q[len ++] = p] = 1;
	}
	for (int i = 0; i < n; i ++) if (v[i]) idx[m ++] = i;
	mm = (m - 1) / BIT + 1; sm = mm * sizeof(int);
	for (int i = 0; i < BIT; i ++) pow[i] = 1 << i;
	for (int i = 0; i < m; i ++)
	{
		int v[MAXNFA] = {0}, q[MAXNFA] = {0}, len = 0;
		v[q[len ++] = i] = 1;
		while (len -- > 0)
		{
			int k = q[len];
			for (int p = 0; p < m; p ++) if ((g[idx[k]][idx[p]] & 1) != 0 && v[p] == 0) v[q[len ++] = p] = 1;
		}
		for (int k = 0; k < m; k ++) if (v[k]) E[i][k >> 5] |= pow[k & 31];
	}
	for (int k = 0; k < sigma; k ++)
		for (int i = 0; i < m; i ++)
		{
			int next[MAXMM] = {0};
			for (int j = 0; j < m; j ++)
				if ((pow[k + 1] & g[idx[i]][idx[j]]) > 0)
					for (int p = 0; p < mm; p ++)
						next[p] |= E[j][p];
			for (int p = 0; p < mm; p ++)
				if (next[p] != 0)
				{
					nx[k][i].p[nx[k][i].l] = p;
					nx[k][i].value[nx[k][i].l ++] = next[p];
				}		
		}
		for (int i = 0; i < m; i ++) if (idx[i] == s) memcpy(start, E[i], sm);
		for (s = t, t = 0; idx[t] != s; t ++);
}

int index(int *node) 
{
	unsigned int h = 0;
	for (int i = 0; i < mm; i ++) h += node[i];
	T_HASH *p = hash[h %= HASH_SIZE];
	while (p != 0)
	{
		if (memcmp(p->node, node, sm) == 0) return p->id;
		p = p->next;
	}
	if (sz < max_sz)
	{
		gg[sz] = p = new T_HASH;
		p->next = hash[h];
		hash[h] = p;
		p->node = new int [mm];
		p->g = new int [sigma];
	} else p = gg[-- sz];
	memcpy(p->node, node, sm);
	memset(p->g, - 1, sigma * sizeof(int));
	final[sz] = (pow[t & 31] & node[t >> 5]) != 0;
	return p->id = sz ++;
}

int *calc(int *now, int *next, int alpha)
{
	memset(next, 0, sm);
	T_LIST *w = nx[alpha];
	for (int hi = 0; hi < mm - 1; hi ++, now ++)
		if (*now == 0) w += 32; else
		for (int lo = 1; lo; lo += lo, w ++)
			if ((lo & *now) != 0) for (int pp = 0; pp < w->l; pp ++)
				next[w->p[pp]] |= w->value[pp];
	if (*now) for (int lo = 1, k = (mm - 1) << 5; k < m; lo += lo, k ++, w ++)
		if ((lo & *now) != 0) for (int pp = 0; pp < w->l; pp ++)
			next[w->p[pp]] |= w->value[pp];
	return next;
}

void init(const char *regular)
{
	n = m = sz = 0;
	for (int i = 0; i < MAXNFA; i ++) memset(g[i] = new int[MAXNFA], 0, sizeof(int) * MAXNFA);
	build_eNFA(regular, 0, (int)strlen(regular) - 1);
	remove_epsilon();
	for (int i = 0; i < MAXNFA; i ++) delete g[i];
	max_sz = (50 << 20) / (4 * (5 + mm + sigma));
	if (m < 30 && (max_sz >> m) > 0) max_sz = (1 << m);
	memset(hash = new T_HASH*[HASH_SIZE], 0, sizeof(T_HASH*) * HASH_SIZE);
	gg = new T_HASH*[max_sz];
	final = new bool[max_sz];
}

void main()
{
	string prefix;
	char regular[MAXRE];
	FILE *inp = fopen("regular.in", "r"), *out = fopen("regular.out", "w");
	fscanf(inp, "%d %s\n", &sigma, regular);
	for (int i = 1; i < sigma; i ++) prefix = prefix + "+" + (char)(i + '0');
	prefix = "(0" + prefix + ")*(" + regular + ")";
	init(prefix.c_str());
	int r = 1, count, now = index(start), next[MAXMM];
	char buf[BUF_SIZE];
	while ((count = (int)fread(buf, sizeof(char), BUF_SIZE, inp)) > 0)
		for (int p = 0; p < count; r ++, p ++)
		{
			int alpha = buf[p] - '0';
			T_HASH *w = gg[now];
			if (w->g[alpha] == - 1 || w->g[alpha] == max_sz - 1) w->g[alpha] = index(calc(w->node, next, alpha));				
			if (final[now = w->g[alpha]]) fprintf(out, "%d ", r);
		}
	fclose(inp);
	fclose(out);
}
